class Trace:# {{{
  def __init__(self, log, trace, events):
    self.log = log
    self.trace = trace
    self.events = events
    self.attribset = {}   # contains each unique attribute key  and unique value in this trace
    for e in events:
      for k,v in e.attrib.items():
        if k in self.attribset:
          self.attribset[k].add(v)
        else:
          self.attribset[k] = {v}
  def __repr__(self):
    return("Log: %s \nTrace: %s\n\Events:\n%s" %(self.log,self.trace,self.events))
# }}}

class Event:# {{{
  def __init__(self, log, trace):
    self.log = log
    self.trace = trace
    self.attrib = {}
  def __init__(self, log, trace, attrib):
    self.log = log
    self.trace = trace
    self.attrib = attrib
  def __repr__(self):
    return("Eventattribs: \n %s\n" % (self.attrib))
# }}}

class EventPair:# {{{
  def __init__(self,ev1,ev2):
    self.ev1 = ev1
    self.ev2 = ev2
  def __repr__(self):
    return("%s\n%s\n" % (self.ev1,self.ev2))

# }}}

class DeltaTs:# {{{
  def __init__(self,evps):
    self.evps = evps
    self.name = evps[0].ev1.attrib['concept:name']+'/'+evps[0].ev2.attrib['concept:name']
    self.stdev = None
    self.intervals = None
    self.criteria = None
    self.perc5 = None
    self.perc95 = None

  def  __eq__(self,other):
    return self.name==other
  #add deltats
  def add_deltats(self,x):
    self.deltats.append(x)
  def __repr__(self):
    return("\n%s\n%s\nDELTAS:%s" % (self.ev1.attrib['concept:name'],self.ev2.attrib['concept:name'],self.deltats))
  #get deltas; return numerical ts
  def get_deltas(self):
    deltas = []
    for x in self.deltats:
      deltas.append(x.delta)
    return(deltas)
  def get_deltanames(self):
    tracenames = []
    for x in self.deltats:
      tracenames.append([x.ev1.trace,x.ev2.trace])
    return(tracenames)
  #set stats, i.e., means, std devs, intervals
  def set_stats(self,op_inp):
     if op_inp =="median" or op_inp == "mean":
       if op_inp == "median":
         self.criteria = statistics.median(self.get_deltas())
       elif op_inp == "mean":
         self.criteria = statistics.mean(self.get_deltas())
       self.stdev = statistics.stdev(self.get_deltas())
       if self.criteria-self.stdev < 0:
         self.intervals = [0,self.criteria+self.stdev]
       self.intervals = [self.criteria-self.stdev,self.criteria+self.stdev]
     elif op_inp == "percentile":
       self.perc5 = np.percentile(self.get_deltas(),0.5)
       self.perc95 = np.percentile(self.get_deltas(),99.5)
     else:
       self.criteria = stats.zscore(self.get_deltas())
# }}}
